'log
'
'Nov 4 morning
'decided to make sound initialize/load routine

'if TRUE and FALSE are not defined, define them here.
#IFNDEF TRUE
CONST FALSE = 0
CONST TRUE = NOT FALSE
#ENDIF

#INCLUDE ONCE "fmod.bi"

DIM SHARED AS INTEGER FMOD_has_no_problem, FMOD_is_not_disabled
DIM SHARED AS INTEGER PTR WAV_ptr(10)

SUB INITIALIZE_SOUND ()

   DIM AS INTEGER i 'loop counter

   'check command line and disable sound if -nosound is passesd
   FMOD_is_not_disabled = INSTR(UCASE(COMMAND), "NOSOUND") = 0

   IF FMOD_is_not_disabled THEN
      FMOD_has_no_problem = TRUE

      'check FMOD version
      IF ( FSOUND_GetVersion() < FMOD_VERSION ) THEN
         FMOD_has_no_problem = FALSE
      END IF

      'initialize FMOD
      IF ( FSOUND_Init(44100, 32, 0) = FALSE ) THEN
         FMOD_has_no_problem = FALSE
      END IF

      'loading all sound samples
      IF FMOD_has_no_problem THEN
         FOR i = 0 TO 8
            WAV_ptr(i) = FSOUND_Sample_Load(i, "WAV\" & i & ".WAV", 0, 0, 0)
            IF WAV_ptr(i) = 0 THEN
               FMOD_has_no_problem = FALSE
            END IF
         NEXT
      END IF
      'DECLARE function FSOUND_Sample_SetDefaults alias "FSOUND_Sample_SetDefaults" (byval sptr as FSOUND_SAMPLE ptr, byval deffreq as integer, byval defvol as integer, byval defpan as integer, byval defpri as integer) as byte

      'FSOUND_Sample_SetDefaults (WAV_ptr(3),  44100*2, 75, -1, -1)

   ELSE
      FMOD_has_no_problem = FALSE 'FMOD is disabled
   END IF

END SUB

SUB PLAY_WAV (BYVAL WAV_ID AS INTEGER, BYVAL channel AS INTEGER = 0, byval volume AS INTEGER = -1)
   'second parameter is sound channel. if omitted, all sounds will use channel 0.

   IF  FMOD_has_no_problem THEN
      FSOUND_Sample_SetDefaults (WAV_ptr(WAV_ID),  -1 , volume, -1, -1) 'try to change volume
      FSOUND_PlaySound(channel, WAV_ptr(WAV_ID)) 'play WAV sound on each sound channel
   END IF
END SUB


'close FMOD if forgot to do...
SUB FMOD_CLEAN_UP DESTRUCTOR
   IF  FMOD_has_no_problem THEN
      FSOUND_close
      ? "FMOD CLOSED"
   END IF
END SUB

/'
'--- test sample ---
INITIALIZE_SOUND () ' call this to initialize FMOD
DO
	SELECT CASE INKEY
		CASE "0" : PLAY_WAV(0) '2nd parameter, CHANNEL is omitted
		CASE "1" : PLAY_WAV(1) 'so, use defaule channel 0
		CASE "2" : PLAY_WAV(2)
		CASE "3" : PLAY_WAV(3)
		CASE "4" : PLAY_WAV(4)
		CASE "5" : PLAY_WAV(5)
		CASE "6" : PLAY_WAV(6)
		CASE "7" : PLAY_WAV(7)
		CASE "8" : PLAY_WAV(8)
		CASE CHR(27) : END
	END SELECT
LOOP
'/
